Graphics3D 800,600,16,2
SetBuffer BackBuffer()
SetFont LoadFont("Arial cyr",16,1)

CreateLight()
CreateCamera()

Stream=OpenTCPStream("localhost",9105)

Global FPSCount = 0
Global FPSCountTemp = 0
Global FPSTime = 0
Const FPS=30

period=1000/FPS
time=MilliSecs()-period

Dim Chat$(15,1)
Global msgChat$

;-------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;-------------------------------------------------------------------------------------------------------------------------------------------------------
Repeat
	Delay 5
	
	Repeat
		elapsed=MilliSecs()-time
	Until elapsed
	ticks=elapsed/period
	tween#=Float(elapsed Mod period)/Float(period)
	
	For k=1 To ticks
		time=time+period
		If k=ticks Then CaptureWorld

		key1$=GetKey1$()
		If key1$="Enter" Then
			WriteLine(Stream,msgChat$):ProcessChat(msgChat$,3):msgChat$=""
		ElseIf key1$="BackSpace" Then
			msgChat$=Mid(msgChat$,1,Len(msgChat$)-1)
		ElseIf Len(key1$)=1 Then
			msgChat$=msgChat$+key1$
		EndIf

		If ReadAvail(Stream)
			message$=ReadLine$(Stream)
			ProcessChat(message,2)
		EndIf
		
		UpdateWorld
	Next
	RenderWorld tween#
	
	For i=1 To 15
		If Chat$(i,1)=1 Then Color 255,0,0
		If Chat$(i,1)=2 Then Color 0,255,0
		If Chat$(i,1)=3 Then Color 255,185,0
		Text 10,600-250+(i*15),Chat$(i,0)
		Color 255,255,255
	Next
	Color 255,255,255
	Text 10,580,">"+msgChat$

	Flip

Forever

;  
Function GetKey1$()

	If KeyHit(28) Then FlushKeys:Return "Enter"
	If KeyHit(14) Then FlushKeys:Return "BackSpace"
	If KeyHit(57) Then FlushKeys:Return " "
	If KeyHit(59) Then FlushKeys:Return Chr(31)
	symb=GetKey()
	If symb>32 And symb<123 Then Return Chr$(symb)
	If symb>191 And symb<256 Then Return Chr$(symb)
	Return ""
	
End Function

;   
Function ProcessChat(ch$,chColor)
	For i=1 To 15
		If Chat$(i,0)="" Then flChat=1:Chat$(i,0)=ch$:Chat$(i,1)=chColor:Exit
	Next
	If flChat=0 Then
		For i=1 To 14
			Chat$(i,0)=Chat$(i+1,0):Chat$(i,1)=Chat$(i+1,1)
		Next
		Chat$(15,0)=ch$:Chat$(15,1)=chColor
	EndIf
End Function